{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,R-,S-,V-}

UNIT Profiler;

INTERFACE

USES DOS;

PROCEDURE InitProfiler;

PROCEDURE ExitProfiler;

PROCEDURE AddProcedure(ID:BYTE;theName:STRING);

PROCEDURE BeginIt(ID:BYTE);

PROCEDURE EndIt(ID:BYTE);

IMPLEMENTATION

CONST maxProc=255;

VAR AdminRec:ARRAY[1..maxProc] OF RECORD
        Used:BOOLEAN;
        Time:LongInt;
        lastTime:LongInt;
        Entered:LongInt;
        Name:String[10]
    END;
    TotalTime:LongInt;


FUNCTION ConvertTime(h,min,sec,sec100:LONGINT):LONGINT;
BEGIN
    ConvertTime:=sec100+sec*100+min*6000+h*360000
END;


PROCEDURE StartStopWatch(VAR StopTime:LongInt);
VAR h,min,sec,sec100:WORD;
BEGIN
    GetTime(h,min,sec,sec100);
    StopTime:=ConvertTime(h,min,sec,sec100)
END;


FUNCTION GetStopWatch(StopTime:LongInt):LONGINT;
VAR h,min,sec,sec100:WORD;
    TimeDiff:LONGINT;
BEGIN
    GetTime(h,min,sec,sec100);
    TimeDiff:=ConvertTime(h,min,sec,sec100)-StopTime;
    IF TimeDiff<0 THEN
        TimeDiff:=TimeDiff+8640000;
    GetStopWatch:=TimeDiff
END;


PROCEDURE InitProfiler;
VAR i:WORD;
BEGIN
    FOR i:=1 TO maxProc DO
        AdminRec[i].Used:=FALSE;
    StartStopWatch(TotalTime)
END;


PROCEDURE ExitProfiler;
VAR i:WORD;
    Total:LongInt;
BEGIN
    Total:=GetStopWatch(TotalTime);
    WriteLn;
    WriteLn('*** Profiler (all times in 1/100 s):');
    WriteLn('Main Program:',Total:10,'   100.0%');
    FOR i:=1 TO maxProc DO
        WITH AdminRec[i] DO
            IF Used THEN
            BEGIN
                Write(name:12,':');
                IF Entered<>0 THEN
                    WriteLn('nesting error')
                ELSE
                    WriteLn(Time:10,'   ',Time/Total*100:5:1,'%')
            END;
    ReadLn;
END;


PROCEDURE AddProcedure(ID:BYTE;theName:STRING);
BEGIN
    WITH AdminRec[ID] DO
    BEGIN
        IF Used THEN
        BEGIN
            WriteLn('AddProcedure(',ID:4,',',theName,')');
            WriteLn('ID already used');
            ReadLn;
            Halt
        END;
        Used:=TRUE;
        Time:=0;
        Entered:=0;
        name:=theName
    END
END;


PROCEDURE BeginIt(ID:BYTE);
BEGIN
    WITH AdminRec[ID] DO
    BEGIN
        IF Entered=0 THEN
            StartStopWatch(lastTime);
        INC(Entered)
    END
END;


PROCEDURE EndIt(ID:BYTE);
BEGIN
    WITH AdminRec[ID] DO
    BEGIN
        DEC(Entered);
        IF Entered=0 THEN
            Time:=Time+GetStopWatch(lastTime)
    END
END;

END.
